-- $Name:Satori$
-- $Version:1.2$

game.codepage="UTF-8";
instead_version "1.9.1";
require "wroom"
require "sprites"
game.gui.ways_delim = ' ';

global {
	sroom_no = 0;
	snext_chip = 1;
	satori_state = 0; --0-normal, 1-minimizing
	sroom_list = {};
	sinv_list = {};
--	sfind_room = -1; -- -1 or no. of room to find
	ssudden_cnt = 0;
	scirc = {}; -- [25], ... [30] {x, y, z} (or false if opened)
	scirc_prog_dist = {}; -- [25..30] (min(r) or false)
	satori_progress = 0;
	satori_progress_old = 0;
	satori_no_progress = 0;
};

stead.mouse_filter(50);


satori_mark = sprite.load 'pics/satori-w.png'
satori_mbox = sprite.box(700, 90, 'white');
satori_mboxb = sprite.box(700, 90, '#606060');

game.pic = function(s)
	local bw;

	if (satori_progress_old == satori_progress) and satori_alpha then
		return satori_alpha;
	end
	satori_progress_old = satori_progress;
	if satori_alpha then
		sprite.free(satori_alpha)
	end
	if satori_bar then
		sprite.free(satori_bar);
	end

-- bar width range: (0..529) + 4
	bw = math.floor((satori_progress / 255) * 529) + 4;

	satori_bar = sprite.blank(700, 83);
	sprite.copy(satori_mark, satori_bar, 0, 0);
	sprite.copy(satori_mboxb, 0, 0, bw, 73, satori_bar, 167, 7);
	sprite.copy(satori_mbox, 0, 0, bw, 73, satori_bar, 165, 5);
	satori_alpha = sprite.blank(700, 83);
	sprite.copy(satori_bar, satori_alpha, 0, 0, satori_progress)
	return satori_alpha
end

-------------------------------------------------------------------------------
srnd = function(mx)
	local r;

	if mx < 1 then return 0; end
	if mx == 1 then return 1; end

	r = stead.ticks() + rnd(mx);
	r = math.floor(r % mx);
	r = r + 1;
	return r;
end;
-------------------------------------------------------------------------------
srnd_test = function()
	local i, ar, n;

	ar = {};
	for i = 1, 100 do
		ar[i] = 0;
	end
	for i = 1, 10000 do
		n = srnd(100);
		if n < 1 or n > 100 then
			print("n=" .. n .. "!!!!!!!!!");
			return false;
		end
		ar[n] = ar[n] + 1;
	end
	for i = 1, 100 do
		print("[" .. i .. "]=" .. ar[i]);
	end
end;
--srnd_test();
-------------------------------------------------------------------------------
srnd_init = function()
	local i, n, t;

	n = srnd(1000);
	for i = 1, n do
		t = srnd(i);
	end
end;

srnd_init();
-------------------------------------------------------------------------------
main = room {
	nam = 'zastavka';
	disp = '';
	enter = function()
		set_music('sounds/bg.ogg');
	end;
	obj = { 'zastobj' };

};
-------------------------------------------------------------------------------
zastobj = obj {
	nam = 'zastobj';
	dsc = function()
		return img('blank:1x160') .. '^' .. txtc('{' .. img('pics/zast.png') .. '}');
	end;
	act = function()
		return walk('startgame');
	end; 

};
-------------------------------------------------------------------------------
-- room attrs:
-- _no - room number
-- _x, _y, _z - room coord
-- nam, disp - functions
-- _state - 0-not opened, 1-opened, 2-circle not opened, 3-circle opened
-- _east (R), _north(G), _up(B), _west(C), _south(M), _down(Y) -
-- - numbers of neighbor rooms
-- way - ways on dummy rooms, which perform redirections
-- _cchip (int) - converter result chip, (0 - absent)
-- _cchip1, _cchip2, _cchip3 - A, B and Res presence (true/false) (_state == 1)
-- _chip (int) - _state==0 - price of room; _state==1 - sudden chip (0-no chip)
-- 	_state==2, 3 - circle chip (0-no chip)
-- _came_from - east/west/north/south/up/down/false
-- _circ3, _circ4, _circ5, _circ6 - (_state==3) presence of price objs (true/false)

-------------------------------------------------------------------------------
sget_room_by_coord = function(x, y, z)
	local i, l, r;

	if sroom_no < 1 then
		return false;
	end
	l = sroom_no - 1;
	for i = 0, l do
		r = sget_room(i);
		if r._x == x and r._y == y and r._z == z then
			return r;
		end
	end
	return false;
end;
-------------------------------------------------------------------------------
sget_room_neighbors_by_coord = function(x, y, z)
	local i, l, ret, rn, r;

	ret = {};
	ret.west = false;
	ret.east = false;
	ret.north = false;
	ret.south = false;
	ret.up = false;
	ret.down = false;
	if sroom_no < 1 then
		return ret;
	end
	l = sroom_no - 1;
	rn = 0;
	for i = 0, l do
		r = sget_room(i);
		if r._x == x - 1 and r._y == y and r._z == z then
			ret.west = r._no;
			rn = rn + 1;
		elseif r._x == x + 1 and r._y == y and r._z == z then
			ret.east = r._no;
			rn = rn + 1;
		elseif r._x == x and r._y == y - 1 and r._z == z then
			ret.south = r._no;
			rn = rn + 1; 
		elseif r._x == x and r._y == y + 1 and r._z == z then
			ret.north = r._no;
			rn = rn + 1;
		elseif r._x == x and r._y == y and r._z == z - 1 then
			ret.down = r._no;
			rn = rn + 1;
		elseif r._x == x and r._y == y and r._z == z + 1 then
			ret.up = r._no; 
			rn = rn + 1;
		end
		assert(rn < 7, "sget_room_neighbors_by_coord: error 1");
		if rn == 6 then
			return ret;
		end
	end
	return ret;
end;
-------------------------------------------------------------------------------
sget_room = function(rno)
	local r;

	if not rno then return false; end
	r = sroom_list[rno];
	if not r then
		return false;
	end
	r = stead.ref(r);
	return r;
end;
-------------------------------------------------------------------------------
shere = function()
	return here();
end;
-------------------------------------------------------------------------------
snowhere = room {
	nam = 'nowhere';
	enter = function()
		return false;
	end;
};
-------------------------------------------------------------------------------
sway_east_bad  = wroom(img('pics/crd.png'), img('pics/crd.png'), snowhere);
sway_north_bad = wroom(img('pics/cgd.png'), img('pics/cgd.png'), snowhere);
sway_up_bad    = wroom(img('pics/cbd.png'), img('pics/cbd.png'), snowhere);
sway_west_bad  = wroom(img('pics/ccd.png'), img('pics/ccd.png'), snowhere);
sway_south_bad = wroom(img('pics/cmd.png'), img('pics/cmd.png'), snowhere);
sway_down_bad  = wroom(img('pics/cyd.png'), img('pics/cyd.png'), snowhere);

sway_east_good  = vroom(img('pics/cr.png'), 'sway_east');
sway_north_good = vroom(img('pics/cg.png'), 'sway_north');
sway_up_good    = vroom(img('pics/cb.png'), 'sway_up');
sway_west_good  = vroom(img('pics/cc.png'), 'sway_west');
sway_south_good = vroom(img('pics/cm.png'), 'sway_south');
sway_down_good  = vroom(img('pics/cy.png'), 'sway_down');
-------------------------------------------------------------------------------
sget_ways = function(d, rm)
	local r, x, y, z;

	x = rm._x;
	y = rm._y;
	z = rm._z;

	r = {};

	if not d then
		if x >= 26 or (satori_state == 1 and not rm._east) then
			table.insert(r, sway_east_bad);
		else
			table.insert(r, sway_east_good);
		end
		if y >= 26 or (satori_state == 1 and not rm._north) then
			table.insert(r, sway_north_bad);
		else
			table.insert(r, sway_north_good);
		end
		if z >= 26 or (satori_state == 1 and not rm._up) then
			table.insert(r, sway_up_bad);
		else
			table.insert(r, sway_up_good);
		end
		if x <= -26 or (satori_state == 1 and not rm._west) then
			table.insert(r, sway_west_bad);
		else
			table.insert(r, sway_west_good);
		end
		if y <= -26 or (satori_state == 1 and not rm._south) then
			table.insert(r, sway_south_bad);
		else
			table.insert(r, sway_south_good);
		end
		if z <= -26 or (satori_state == 1 and not rm._down) then
			table.insert(r, sway_down_bad);
		else
			table.insert(r, sway_down_good);
		end
		return r;
	end

	if d == 'east' then
		table.insert(r, sway_east_good);
	else
		table.insert(r, sway_east_bad);
	end
	if d == 'north' then
		table.insert(r, sway_north_good);
	else
		table.insert(r, sway_north_bad);
	end
	if d == 'up' then
		table.insert(r, sway_up_good);
	else
		table.insert(r, sway_up_bad);
	end
	if d == 'west' then
		table.insert(r, sway_west_good);
	else
		table.insert(r, sway_west_bad);
	end
	if d == 'south' then
		table.insert(r, sway_south_good);
	else
		table.insert(r, sway_south_bad);
	end
	if d == 'down' then
		table.insert(r, sway_down_good);
	else
		table.insert(r, sway_down_bad);
	end
	return r;
end;
-------------------------------------------------------------------------------
screate_room_constructor = function(rno, x, y, z)
	local r, i;

	r = sget_room_by_coord(x, y, z);
	assert(r == false, "screate_room_constructor: error 1");
	r = {};
 	r._no = rno;
	r._state = 0;
	r._x = x;
	r._y = y;
	r._z = z;
	r._cchip = 0;
	r._cchip1 = false;
	r._cchip2 = false;
	r._cchip3 = false;
	r._circ3 = false;
	r._circ4 = false;
	r._circ5 = false;
	r._circ6 = false;

	r._came_from = false;

	r.nam = function(s)
		return 'r' .. s._no;
	end;

	r.disp = function(s)
		return s._no;
	end;

--	r.dsc = '';
--	r.forcedsc = true;

	r.enter = function(s)
		local ws, i;

		if satori_state == 1 and
			s._x == 0 and s._y == 0 and s._z == 0 then
			return walk('satori_room');
		end

		objs():zap();
		if s._state == 0 then
			objs():add('sprice_obj_spc');
			objs():add('sprice_obj');
		elseif s._state == 1 then
			objs():add('sconv_spc0');
			objs():add('sconv_obj3');
			objs():add('sconv_spc1');
			objs():add('ssudden_obj');
			objs():add('sconv_spc2');
			objs():add('sconv_obj1');
			objs():add('sconv_spc3');
			objs():add('sconv_obj2');
--			objs():add('sconv_spc4');
--			objs():add('sfind_obj');
		elseif s._state == 2 then
			objs():add('sprice_obj_spc');
			objs():add('sprice_circ3'); 
			objs():add('sprice_circ4'); 
			objs():add('sprice_circ5'); 
			objs():add('sprice_circ6'); 
		elseif s._state == 3 then
			objs():add('sprice_obj_spc');
			objs():add('scirc_obj');
		else
			assert(false, "room.enter: error 1");
		end;

		ways():zap();

		if s._state == 0 or s._state == 2 then
			assert(s._came_from, "room.enter: error 2");
			ws = sget_ways(s._came_from, s);
		elseif s._state == 1 or s._state == 3 then
			ws = sget_ways(false, s);
		end;
		assert(#ws == 6, "room.enter: error 3");
		for i = 1, 6 do
			ways():add(ws[i]);
		end

		return true;
	end;

	return room(r);
end;
-------------------------------------------------------------------------------
sget_price = function(x, y, z)
	local r, i, r1;

	r = 1000000;
	for i = 25, 30 do
		if scirc[i] then
			r1 = sget_dist(scirc[i].x - x, 
				scirc[i].y - y, scirc[i].z - z);
			if r > r1 then r = r1; end
		end
	end
	r = math.floor(25 - r);

	if r < 1 then r = 1; end
	return r;
end;
-------------------------------------------------------------------------------
sif_circle_room = function(x, y, z)
	local i;

	for i = 25, 30 do
		if scirc[i] then
			if 	x == scirc[i].x and
				y == scirc[i].y and
				z == scirc[i].z then
				return i;
			end
		end
	end
	return false;
end;
-------------------------------------------------------------------------------
screate_room = function(x, y, z)
	local r, rn, n, ifc;

	rn = sroom_no;
	r = new('screate_room_constructor('.. rn ..', ' .. x .. ', ' .. y ..
		',' .. z .. ')');
	assert(r, 'screate_room: error 1');

	n = sget_room_neighbors_by_coord(x, y, z);
	r._east = n.east;
	r._west = n.west;
	r._north = n.north;
	r._south = n.south;
	r._up = n.up;
	r._down = n.down;

	ifc = sif_circle_room(x, y, z);
	if ifc then
		r._state = 2;
		r._chip = ifc;
	else 
		r._chip = sget_price(x, y, z);
	end

	if r._east then
		rn = sget_room(r._east);
		rn._west = r._no; 
--print('reast');
	end
	if r._west then 
		rn = sget_room(r._west);
		rn._east = r._no;
--print('rwest');
	end
	if r._south then 
		rn = sget_room(r._south);
		rn._north = r._no;
	end
	if r._north then 
		rn = sget_room(r._north);
		rn._south = r._no;
	end
	if r._up then 
		rn = sget_room(r._up);
		rn._down = r._no;
	end
	if r._down then 
		rn = sget_room(r._down);
		rn._up = r._no;
	end

	sroom_list[sroom_no] = stead.deref(r);
	sroom_no = sroom_no + 1;
	set_sound('sounds/new_room.wav');
	return r;
end;
-------------------------------------------------------------------------------
sopen_room = function(r)
-- only normal rules (not circle rooms)
	assert(r._state == 0, 'sopen_room: error 1');
	if r._chip == snext_chip and snext_chip < 25 then
		snext_chip = snext_chip + 1;
		r._cchip = snext_chip;
	else
		r._cchip = r._chip + 1;
	end
	if r._cchip > 24 then r._cchip = 24; end
	r._state = 1;
	r._cchip1 = false;
	r._cchip2 = false;
	r._cchip3 = false;
	r._chip = 0;
	sprog_new_room(r._x, r._y, r._z);
	set_sound('sounds/open_room.wav');

	return true;
end;
-------------------------------------------------------------------------------
sset_new_conv = function(chip, allow_auto)
	local r;

	if chip > 23 then return false; end
	r = here();
	if not r._state then return false; end
	if r._state ~= 1 then return false; end
	if r._cchip == chip + 1 then
		if not allow_auto then return false; end
		return sauto_use_chip(chip);
	end
	if r._cchip1 or r._cchip2 or r._cchip3 then return false; end
	r._cchip = chip + 1;
	sinv_del(chip);
	return true;
end;
-------------------------------------------------------------------------------
sauto_use_chip = function(chip)
	local r;

	r = here();
	if not r._cchip1 then 
		r._cchip1 = true;
		sinv_del(chip);
		scheck_conv(r);
		return true;
	end
	if not r._cchip2 then 
		r._cchip2 = true;
		sinv_del(chip);
		scheck_conv(r);
		return true;
	end
	return false;
end;
-------------------------------------------------------------------------------
sinv_create_constructor = function(chip)
	local o;

	o = {};
	o._chip = chip;
	o._qty = 0;
	o.nam = function(s)
		local p;
		
		p = sget_pic(s._chip, true);
		assert(p, 'sinv_create_constructor: error 1');
		p = img(p);
		p = img('blank:35x1') .. p;
		if s._qty == 1 then 
			return p;
		end
		p = p .. ' ' .. s._qty;
		return p;
	end;

	o.inv = function(s)
		return sset_new_conv(s._chip, true);
-- (sfind_room)
--		local i, pass, r;
--		i = srnd(sroom_no) - 1;
--		pass = 0;
--		while pass < 2 do
--			r = sget_room(i);
--			if r._state == 1 and 
--				r._cchip - 1 == s._chip then
--				sfind_room = r._no;
--				sinv_del(s._chip);
--				return true;
--			end
--			i = i + 1;
--			if i >= sroom_no then
--				pass = pass + 1;
--				i = 0;
--			end
--		end
--		return false;
	end;

	return obj(o);
end;
-------------------------------------------------------------------------------
sinv_init = function()
	local i, o;

	for i = 1, 30 do 
		o = new('sinv_create_constructor(' .. i .. ')');
		assert(o, 'sinv_init: error 1');
		sinv_list[i] = stead.deref(o);
	end
	return true;
end;
-------------------------------------------------------------------------------
startgame = room {
	nam = 'startgame';
	enter = function()
		local r0;
		sinv_init();
		scirc_init();
		r0 = screate_room(0, 0, 0);
		sopen_room(r0);
		r0._chip = 1;
		lifeon('slife');
		set_sound('sounds/new_room.wav');
		return walk(r0);
	end;
};
-------------------------------------------------------------------------------
sget_pic = function(chip, on)
	local s, n;

	if chip < 1 or chip > 30 then
		return false;
	end

	s = 'pics/';

	n = math.floor((chip - 1) / 6) + 3;
	if n > 6 then
		n = 'c';
	end
	s = s .. n;
	
	n = math.floor(chip - 1) % 6;
	if n == 0 then
		s = s .. 'r';
	elseif n == 1 then
		s = s .. 'g';
	elseif n == 2 then
		s = s .. 'b';
	elseif n == 3 then
		s = s .. 'c';
	elseif n == 4 then
		s = s .. 'm';
	elseif n == 5 then
		s = s .. 'y';
	end

	if not on then
		s = s .. 'd';
	end

	s = s .. '.png';

	return s;
end;
-------------------------------------------------------------------------------
sinv_update = function()
	local i, o;
	inv():zap();
	for i = 1, 30 do
		o = stead.ref(sinv_list[i]);
		if o._qty > 0 then
			inv():add(o);
		end
	end
	return true;
end;
-------------------------------------------------------------------------------
sinv_add = function(chip)
	local o;
	if chip < 1 or chip > 30 then
		assert(false, 'sinv_add: error 1');
	end
	o = stead.ref(sinv_list[chip]);
	assert(o, 'sinv_add: error 2');
	o._qty = o._qty + 1;
	sinv_update();
	return true;
end;
-------------------------------------------------------------------------------
sinv_del = function(chip)
	local o;
	if chip < 1 or chip > 30 then
		assert(false, 'sinv_del: error 1');
	end
	o = stead.ref(sinv_list[chip]);
	assert(o, 'sinv_del: error 2');
	assert(o._qty > 0, 'sinv_del: error 3');
	o._qty = o._qty - 1;
	sinv_update();
	return true;
end;
-------------------------------------------------------------------------------
sprice_obj_spc = obj {
	nam = 'sprice_obj_spc';
	dsc = function()
		return img("blank:1x150") .. "^";
	end;
};
-------------------------------------------------------------------------------
sprice_obj = obj {
	nam = 'sprice_obj';

	dsc = function()
		local r, pic;

		r = here();
		pic = sget_pic(r._chip, false);
		assert(pic, "sprice_obj:dsc: error 1");
		return txtc("{" .. img(pic) .. "}");
	end;

	act = function()
		local r;

		r = here();
		if not shave_chip(r._chip) then return false; end
		sinv_del(r._chip);
		sopen_room(r);
		walk(r);
		return true;
	end;

	used = function(s, w)
		local r;

		if not w then return false; end
		if not w._chip then return false; end
		r = here();
		if w._chip ~= r._chip then return false; end
		sinv_del(w._chip);
		sopen_room(r);
		walk(r);
		return true;
	end;
};
-------------------------------------------------------------------------------
sconv_spc0 = obj {
	nam = 'sconv_spc0';
	dsc = function()
		return img('blank:1x10') .. "^";
	end;
};
-------------------------------------------------------------------------------
sconv_obj3 = obj {
	nam = 'sconv_obj3';
	dsc = function()
		local r, pic, on;
		
		r = here();
		on = r._cchip3;
		pic = sget_pic(r._cchip, on);
		on = true;
		if not pic then
			on = false;
			pic = 'blank:78x78';
		end
		pic = img(pic);
		if on then 
			pic = '{' .. pic .. '}';
		end
		return txtc(pic);
	end;

	act = function()
		local r;

		r = here();
		if not r._cchip3 then return false; end
		sinv_add(r._cchip);
		r._cchip3 = false;
		scheck_conv(r);
		return true;
	end;

	used = function(s, w)
		if not w then return false; end
		if not w._chip then return false; end
		if w._chip < 2 then return false; end
		return sset_new_conv(w._chip - 1, false);
	end;
};
-------------------------------------------------------------------------------
sconv_spc1 = obj {
	nam = 'sconv_spc1';
	dsc = function()
		return "^" .. img('blank:1x62') .. "^";
	end;
};
-------------------------------------------------------------------------------
ssudden_obj = obj {
	nam = 'ssudden_obj';
	dsc = function()
		local r, pic;
		
		r = here();
		pic = sget_pic(r._chip, true);
		if not pic or satori_state ~= 0 then
			pic = img('blank:78x78');
		else
			pic = '{' .. img(pic) .. '}';
		end
		return txtc(pic);
	end;

	act = function()
		local r;

		r = here();
		if r._chip < 1 then return false; end;
		sinv_add(r._chip);
		r._chip = 0;
		return true;
	end;
};
-------------------------------------------------------------------------------
sconv_spc2 = obj {
	nam = 'sconv_spc2';
	dsc = function()
		return "^" .. img('blank:1x15') .. "^";
	end;
};
-------------------------------------------------------------------------------
scheck_conv = function(r)
	if r._cchip1 and r._cchip2 and not r._cchip3 then
		r._cchip1 = false;
		r._cchip2 = false;
		r._cchip3 = true;
		set_sound('sounds/new_chip.wav');
	end
	return true;
end;
-------------------------------------------------------------------------------
sconv_obj1 = obj {
	nam = 'sconv_obj1';
	dsc = function()
		local r, pic, on;
		
		r = here();
		on = r._cchip1;
		pic = sget_pic(r._cchip - 1, on);
		on = true;
		if not pic then
			on = false;
			pic = 'blank:78x78';
		end
		pic = img(pic);
		if on then 
			pic = '{' .. pic .. '}';
		end
		return txtc(pic);
	end;

	act = function() -- take away the chip to inventory
		local r;

		r = here();
		if not r._cchip1 then 
			if not shave_chip(r._cchip - 1) then
				return false; 
			end
			sinv_del(r._cchip - 1);
			r._cchip1 = true;
			scheck_conv(r);
			return true;
		end
		r._cchip1 = false;
		sinv_add(r._cchip - 1);
		return true;
	end;

	used = function(s, w) -- put the chip from inventory
		local r;
		r = here();
		if r._cchip1 then return false; end
		if not w then return false; end
		if not w._chip then return false; end
		if w._chip ~= r._cchip - 1 then 
			return sset_new_conv(w._chip, false);
		end
		sinv_del(w._chip);
		r._cchip1 = true;
		scheck_conv(r);
		return true;
	end;
};
-------------------------------------------------------------------------------
sconv_spc3 = obj {
	nam = 'sconv_spc3';
	dsc = function()
		return txtc(img('blank:180x78'));
	end;
};
-------------------------------------------------------------------------------
sconv_obj2 = obj {
	nam = 'sconv_obj2';
	dsc = function()
		local r, pic, on;
		
		r = here();
		on = r._cchip2;
		pic = sget_pic(r._cchip - 1, on);
		on = true;
		if not pic then
			on = false;
			pic = 'blank:78x78';
		end
		pic = img(pic);
		if on then 
			pic = '{' .. pic .. '}';
		end
		return txtc(pic);
	end;

	act = function() -- take away the chip to inventory
		local r;

		r = here();
		if not r._cchip2 then
			if not shave_chip(r._cchip - 1) then
				return false; 
			end
			sinv_del(r._cchip - 1);
			r._cchip2 = true;
			scheck_conv(r);
			return true;
		end
		r._cchip2 = false;
		sinv_add(r._cchip - 1);
		return true;
	end;

	used = function(s, w) -- put the chip from inventory
		local r;
		r = here();
		if r._cchip2 then return false; end
		if not w then return false; end
		if not w._chip then return false; end
		if w._chip ~= r._cchip - 1 then 
			return sset_new_conv(w._chip, false);
		end
		sinv_del(w._chip);
		r._cchip2 = true;
		scheck_conv(r);
		return true;
	end;
};
-------------------------------------------------------------------------------
--sconv_spc4 = obj {
--	nam = 'sconv_spc4';
--	dsc = function()
--		return "^" .. img('blank:1x70') .. "^";
--	end;
--};
-------------------------------------------------------------------------------
--sfind_obj = obj {
--	nam = 'sfind_obj';
--	dsc = function()
--		local r, dx, dy, dz, r2;
--
--		r = here();
--		if r._state ~= 1 or sfind_room < 0 then
--			return '';
--		end
--		r2 = sget_room(sfind_room);
--		assert(r2, 'sfind_obj:dsc: error 1');
--		dx = r._x - r2._x;
--		dy = r._y - r2._y;
--		dz = r._z - r2._z;
--		if dx == 0 and dy == 0 and dz == 0 then
--			sfind_room = -1;
--		end
--		return txtc(dx .. ' ' .. dy .. ' ' .. dz);
--	end;
--};
-------------------------------------------------------------------------------
scheck_circ = function(r)

	if not (r._circ3 and r._circ4 and r._circ5 and r._circ6) then
		return true;
	end
	-- opening room
	r._state = 3;
	scirc[r._chip] = false;
	set_sound('sounds/circle.ogg');

	return walk(r);
end;
-------------------------------------------------------------------------------
sprice_circ3 = obj {
	nam = 'sprice_circ3';

	dsc = function()
		local r, pic;
		
		r = here();
		assert(r._chip >= 25 and r._chip <= 30, "sprice_circ3.dsc: error 1");
		pic = sget_pic(r._chip - 24, r._circ3);
		return txtc('{' .. img(pic) .. '}' .. img('blank:60x78'));
	end;

	act = function()
		local r, ch;

		r = here();
		ch = r._chip - 24; 
		if not r._circ3 then
			if not shave_chip(ch) then return false; end
			sinv_del(ch);
			r._circ3 = true;
			scheck_circ(r);
			return true;
		end
		sinv_add(ch);
		r._circ3 = false;
		return true;
	end;

	used = function(s, w)
		local r, ch;

		r = here();
		if r._circ3 then return false; end
		ch = r._chip - 24;
		if not w then return false; end
		if not w._chip then return false; end
		if w._chip ~= ch then return false; end
		sinv_del(ch);
		r._circ3 = true;
		scheck_circ(r);
		return true;
	end;
};
-------------------------------------------------------------------------------
sprice_circ4 = obj {
	nam = 'sprice_circ4';

	dsc = function()
		local r, pic;
		
		r = here();
		assert(r._chip >= 25 and r._chip <= 30, "sprice_circ4.dsc: error 1");
		pic = sget_pic(r._chip - 18, r._circ4);
		return txtc('{' .. img(pic) .. '}' .. img('blank:60x78'));
	end;

	act = function()
		local r, ch;

		r = here();
		ch = r._chip - 18; 
		if not r._circ4 then 
			if not shave_chip(ch) then return false; end
			sinv_del(ch);
			r._circ4 = true;
			scheck_circ(r);
			return true;
		end
		sinv_add(ch);
		r._circ4 = false;
		return true;
	end;

	used = function(s, w)
		local r, ch;

		r = here();
		if r._circ4 then return false; end
		ch = r._chip - 18;
		if not w then return false; end
		if not w._chip then return false; end
		if w._chip ~= ch then return false; end
		sinv_del(ch);
		r._circ4 = true;
		scheck_circ(r);
		return true;
	end;
};
-------------------------------------------------------------------------------
sprice_circ5 = obj {
	nam = 'sprice_circ5';

	dsc = function()
		local r, pic;
		
		r = here();
		assert(r._chip >= 25 and r._chip <= 30, "sprice_circ5.dsc: error 1");
		pic = sget_pic(r._chip - 12, r._circ5);
		return txtc('{' .. img(pic) .. '}' .. img('blank:60x78'));
	end;

	act = function()
		local r, ch;

		r = here();
		ch = r._chip - 12; 
		if not r._circ5 then 
			if not shave_chip(ch) then return false; end
			sinv_del(ch);
			r._circ5 = true;
			scheck_circ(r);
			return true;
		end
		sinv_add(ch);
		r._circ5 = false;
		return true;
	end;

	used = function(s, w)
		local r, ch;

		r = here();
		if r._circ5 then return false; end
		ch = r._chip - 12;
		if not w then return false; end
		if not w._chip then return false; end
		if w._chip ~= ch then return false; end
		sinv_del(ch);
		r._circ5 = true;
		scheck_circ(r);
		return true;
	end;
};
-------------------------------------------------------------------------------
sprice_circ6 = obj {
	nam = 'sprice_circ6';

	dsc = function()
		local r, pic;
		
		r = here();
		assert(r._chip >= 25 and r._chip <= 30, "sprice_circ6.dsc: error 1");
		pic = sget_pic(r._chip - 6, r._circ6);
		return txtc('{' .. img(pic) .. '}');
	end;

	act = function()
		local r, ch;

		r = here();
		ch = r._chip - 6; 
		if not r._circ6 then 
			if not shave_chip(ch) then return false; end
			sinv_del(ch);
			r._circ6 = true;
			scheck_circ(r);
			return true;
		end
		sinv_add(ch);
		r._circ6 = false;
		return true;
	end;

	used = function(s, w)
		local r, ch;

		r = here();
		if r._circ6 then return false; end
		ch = r._chip - 6;
		if not w then return false; end
		if not w._chip then return false; end
		if w._chip ~= ch then return false; end
		sinv_del(ch);
		r._circ6 = true;
		scheck_circ(r);
		return true;
	end;
};
-------------------------------------------------------------------------------
scirc_obj = obj {
	nam = 'scirc_obj';

	dsc = function()
		local r, pic;

		r = here();
		if r._chip > 0 then
			pic = sget_pic(r._chip, true);
			assert(pic, "scirc_obj.dsc: error 1");
			pic = '{' .. img(pic) .. '}';
		else
			pic = img('blank:78x78');
		end
		return txtc(pic);
	end;

	act = function()
		local r;

		r = here();
		if r._chip == 0 then return false; end
		sinv_add(r._chip);
		r._chip = 0;
		return true;
	end;
};
-------------------------------------------------------------------------------
sway_east = room {
	nam = 'sway_east';
	enter = function(s, from)
		local to, ton;

		assert(from, 'sway_east: error 1');
		ton = from._east;
		if not ton then
			if satori_state == 0 then
				to = screate_room(from._x + 1, from._y, from._z);
			else
				return false; -- walk back if no room
			end
		else
			set_sound('sounds/ahead.wav');
			to = sget_room(ton);
		end;
		to._came_from = 'west';
		--sadd_sudden_chip();
		return walk(to);
	end;
};
-------------------------------------------------------------------------------
sway_west = room {
	nam = 'sway_west';
	enter = function(s, from)
		local to, ton;

		assert(from, 'sway_west: error 1');
		ton = from._west;
		if not ton then
			if satori_state == 0 then
				to = screate_room(from._x - 1, from._y, from._z);
			else
				return false; -- walk back if no room
			end
		else
			to = sget_room(ton);
			set_sound('sounds/back.wav');
		end;
		to._came_from = 'east';
		--sadd_sudden_chip();
		return walk(to);
	end;

};
-------------------------------------------------------------------------------
sway_north = room {
	nam = 'sway_north';
	enter = function(s, from)
		local to, ton;

		assert(from, 'sway_north: error 1');
		ton = from._north;
		if not ton then
			if satori_state == 0 then
				to = screate_room(from._x, from._y + 1, from._z);
			else
				return false; -- walk back if no room
			end
		else
			to = sget_room(ton);
			set_sound('sounds/ahead.wav');
		end;
		to._came_from = 'south';
		--sadd_sudden_chip();
		return walk(to);
	end;
};
-------------------------------------------------------------------------------
sway_south = room {
	nam = 'sway_south';
	enter = function(s, from)
		local to, ton;

		assert(from, 'sway_south: error 1');
		ton = from._south;
		if not ton then
			if satori_state == 0 then
				to = screate_room(from._x, from._y - 1, from._z);
			else
				return false; -- walk back if no room
			end
		else
			to = sget_room(ton);
			set_sound('sounds/back.wav');
		end;
		to._came_from = 'north';
		--sadd_sudden_chip();
		return walk(to);
	end;
};
-------------------------------------------------------------------------------
sway_up = room {
	nam = 'sway_up';
	enter = function(s, from)
		local to, ton;

		assert(from, 'sway_up: error 1');
		ton = from._up;
		if not ton then
			if satori_state == 0 then
				to = screate_room(from._x, from._y, from._z + 1);
			else
				return false; -- walk back if no room
			end
		else
			to = sget_room(ton);
			set_sound('sounds/ahead.wav');
		end;
		to._came_from = 'down';
		--sadd_sudden_chip();
		return walk(to);
	end;
};
-------------------------------------------------------------------------------
sway_down = room {
	nam = 'sway_down';
	enter = function(s, from)
		local to, ton;

		assert(from, 'sway_down: error 1');
		ton = from._down;
		if not ton then
			if satori_state == 0 then
				to = screate_room(from._x, from._y, from._z - 1);
			else
				return false; -- walk back if no room
			end
		else
			to = sget_room(ton);
			set_sound('sounds/back.wav');
		end;
		to._came_from = 'up';
		--sadd_sudden_chip();
		return walk(to);
	end;
};
-------------------------------------------------------------------------------
sget_sudden_chip = function()
	local i, s, n, r;
	
	if snext_chip < 3 then
		return 1;
	end

-- for linear distribution (debug)
--	return srnd(snext_chip - 1);

	n = snext_chip - 1;	
	s = (1 + n) * n;
	s = s / 2;
	i = 1;
	r = srnd(s);
	while n > 0 do
		if r <= i then return n; end;
		n = n - 1;
		r = r - i;
		i = i + 1;
	end
	assert(false, 'sget_sudden_chip: error 1');
	return 1;
	
end;
-------------------------------------------------------------------------------
shave_chip = function(chip)
	local c;

	if chip < 1 or chip > 30 then return false; end
	c = stead.ref(sinv_list[chip]);
	if c._qty > 0 then return true; end
	return false;
end;
-------------------------------------------------------------------------------
scheck_all_circles = function()
	local i, o;

	if satori_state ~= 0 then return true; end
	for i = 25, 30 do
		if not shave_chip(i) then return true; end
	end
	satori_state = 1; -- begin Satori! :)
	return true;
end;
-------------------------------------------------------------------------------
satori_minimize = function()
	local r, r1;

	if satori_state ~= 1 then return true; end
	if sroom_no < 2 then return true; end
	r = here();

	if not r then return true; end
	if not r._no then return true; end
	if sroom_no == r._no + 1 then return true; end

	-- deleting room

	sroom_no = sroom_no - 1;
	r = sget_room(sroom_no);
	assert(r, 'satori_minimize: error 1');
	
	r1 = sget_room(r._east); if r1 then r1._west = false; end
	r1 = sget_room(r._west); if r1 then r1._east = false; end
	r1 = sget_room(r._north); if r1 then r1._south = false; end
	r1 = sget_room(r._south); if r1 then r1._north = false; end
	r1 = sget_room(r._up); if r1 then r1._down = false; end
	r1 = sget_room(r._down); if r1 then r1._up = false; end

	delete(r);
	sroom_list[sroom_no] = nil;

	return true;
end;
-------------------------------------------------------------------------------
slife = obj {
	nam = 'slife';
	life = function()
		scheck_all_circles();
		sadd_sudden_chip();
		satori_minimize();
		sprog_check();
	end;
};
-------------------------------------------------------------------------------
sadd_sudden_chip = function()
	local i, r, t, pass, i2;

	if satori_state ~= 0 then  
		return true;
	end

	if ssudden_cnt < 3 then
		ssudden_cnt = ssudden_cnt + 1;
		return true;
	else
		ssudden_cnt = 0;
	end

	i = srnd(sroom_no) - 1;
	i2 = i;
	t = true;
	pass = 0;
	while t do 
		r = sget_room(i);
		if 	r._state == 1 and 
			r._chip == 0 and
			r ~= here() then 

			t = false;
			r._chip = sget_sudden_chip();
		end
		i = i + 1;
		if i >= sroom_no then 
			pass = pass + 1;
			i = 0;
		end
		if pass > 0 and i >= i2 then
			t = false;
		end 
	end
	return true;
end;
-------------------------------------------------------------------------------
sget_dist = function(dx, dy, dz)
	return math.floor(math.sqrt((dx * dx) + (dy * dy) + (dz * dz)));
end;
-------------------------------------------------------------------------------
scirc_inc_coord = function(c)
	local r;

	if math.abs(c) >= 26 then return c; end
	if c > 0 then
		r = c + 1;
	else
		r = c - 1;
	end
	return r;
end;
-------------------------------------------------------------------------------
scirc_inc_coords = function(c)
	local i, pass, t;

	i = srnd(3);
	pass = 0;
	while i > 0 do
	
		-- x --
		if i == 1 then 
			t = scirc_inc_coord(c.x);
			if t == c.x then 
				i = i + 1; 
			else 
				c.x = t;
				return true;
			end
		end
		i = i - 1;

		-- y --
		if i == 1 then 
			t = scirc_inc_coord(c.y);
			if t == c.y then 
				i = i + 1; 
			else 
				c.y = t;
				return true;
			end
		end
		i = i - 1;

		-- z --
		if i == 1 then 
			t = scirc_inc_coord(c.z);
			if t == c.z then 
				i = i + 1; 
			else 
				c.z = t;
				return true;
			end
		end
		i = i - 1;

		pass = pass + 1;
		assert(pass < 2, 'scirc_inc_coord: error 1 - inf. loop');
	end
	assert(false, 'scirc_inc_coord: error 2');
end;
-------------------------------------------------------------------------------
scirc_new_coords = function(dirs)
	local r, di;

	r = {};
	srnd_init();
	r.x = srnd(26);
	r.y = srnd(26);
	r.z = srnd(26);
--print('1st: ' .. r.x .. ', ' .. r.y .. ', ' .. r.z);
	while sget_dist(r.x, r.y, r.z) < 25 do
		scirc_inc_coords(r);
	end
--print('2nd: ' .. r.x .. ', ' .. r.y .. ', ' .. r.z);
	di = srnd(8);
	while not dirs[di] do
		di = di + 1;
		if di > 8 then di = 1; end
	end
	r.x = r.x * dirs[di].cx;
	r.y = r.y * dirs[di].cy;
	r.z = r.z * dirs[di].cz;
	dirs[di] = false;
	return r;
end;
-------------------------------------------------------------------------------
scirc_init = function()
	local crd, i, j, t, dirs;

	dirs = {};
	dirs[1] = { cx = 1; cy = 1; cz = 1; };
	dirs[2] = { cx = 1; cy = 1; cz =-1; };
	dirs[3] = { cx = 1; cy =-1; cz = 1; };
	dirs[4] = { cx = 1; cy =-1; cz =-1; };
	dirs[5] = { cx =-1; cy = 1; cz = 1; };
	dirs[6] = { cx =-1; cy = 1; cz =-1; };
	dirs[7] = { cx =-1; cy =-1; cz = 1; };
	dirs[8] = { cx =-1; cy =-1; cz =-1; };

	for i = 25, 30 do 
		scirc[i] = scirc_new_coords(dirs);
		scirc_prog_dist[i] = 26;
	end

--	for i = 26, 30 do
--		t = true;
--		while t do
--			scirc[i] = scirc_new_coords();
--			t = false;
--			for j = 25, i - 1 do
--				if scirc[j].x == scirc[i].x and
--					scirc[j].y == scirc[i].y and
--					scirc[j].z == scirc[i].z then
--					t = true;
--				end
--			end
--		end
--	end

--for i = 25, 30 do
--print(scirc[i].x .. ', ' .. scirc[i].y .. ', ' .. scirc[i].z);
--end

--TOD-DEBUG
--scirc[25].x = 26;
--scirc[25].y = 0;
--scirc[25].z = 0;
--
--scirc[26].x = -26;
--scirc[26].y = 0;
--scirc[26].z = 0;
--
--scirc[27].x = 0;
--scirc[27].y = 26;
--scirc[27].z = 0;
--
--scirc[28].x = 0;
--scirc[28].y = -26;
--scirc[28].z = 0;
--
--scirc[29].x = 0;
--scirc[29].y = 0;
--scirc[29].z = 26;
--
--scirc[30].x = 0;
--scirc[30].y = 0;
--scirc[30].z = -26;
--
--for i = 1, 24 do
--for j = 1, 50 do
--	sinv_add(i);
--end
--end
	
	return true;
end;
-------------------------------------------------------------------------------
sprog_new_room = function(x, y, z)
	local i, r;

	for i = 25, 30 do
		if not scirc[i] then 
			scirc_prog_dist[i] = false;
		else
			r = sget_dist(scirc[i].x - x, scirc[i].y - y, scirc[i].z - z);
			if r < scirc_prog_dist[i] then
				scirc_prog_dist[i] = r;
			end
		end
	end
	return true;
end;
-------------------------------------------------------------------------------
sprog_check = function()
	local i, r, fl, rt;

	if satori_no_progress > 0 then
		satori_progress = 0;
		return true;
	end
	fl = 0;
	r = 26;
	for i = 25, 30 do
		if not scirc_prog_dist[i] then
			fl = fl + 1;
		else
			if scirc_prog_dist[i] < r then
				r = scirc_prog_dist[i];
			end
		end
	end
	r = 26 - r;
	r = math.floor((r / 26) * 43);
	rt = fl * 43 + r;
	if rt > 255 then rt = 255; end
	satori_progress = rt;
	return true;
end;
-------------------------------------------------------------------------------
satori_obj_spc = obj {
	nam = 'satori_obj_spc';
	dsc = function()
		return img("blank:1x228") .. "^";
	end;
};
-------------------------------------------------------------------------------
satori_room = room {
	nam = '0';
--	forcedsc = true;
--	dsc = '';

	enter = function()
		local i, o;

		satori_no_progress = 1;
		for i = 1, 24 do
			o = stead.ref(sinv_list[i]);
			o._qty = 0;
		end
		sinv_update();
	end;

	obj = { 'satori_obj_spc', 
		'sat_obj1', 'sat_obj2', 'sat_obj3', 
		'sat_obj4', 'sat_obj5', 'sat_obj6' };

--	way = { sway_east_bad, sway_north_bad, sway_up_bad, 
--		sway_west_bad, sway_south_bad, sway_down_bad };
}
-------------------------------------------------------------------------------
sat_obj1 = obj {
	nam = 'sat_obj1';

	_chip = false;

	dsc = function(s)
		local pic;

		pic = sget_pic(25, s._chip);
		return txtc('{' .. img(pic) .. '} ');
	end;

	act = function(s)
		if not s._chip then return false; end
		sinv_add(25);
		s._chip = false;
		return true;
	end;

	used = function(s, w)
		if s._chip then return false; end
		if not w then return false; end
		if not w._chip then return false; end
		if w._chip ~= 25 then return false; end
		sinv_del(25);
		s._chip = true;
		sat_objs_check();
		return true;
	end;
};
-------------------------------------------------------------------------------
sat_obj2 = obj {
	nam = 'sat_obj2';

	_chip = false;

	dsc = function(s)
		local pic;

		pic = sget_pic(26, s._chip);
		return txtc('{' .. img(pic) .. '} ');
	end;

	act = function(s)
		if not s._chip then return false; end
		sinv_add(26);
		s._chip = false;
		return true;
	end;

	used = function(s, w)
		if s._chip then return false; end
		if not w then return false; end
		if not w._chip then return false; end
		if w._chip ~= 26 then return false; end
		sinv_del(26);
		s._chip = true;
		sat_objs_check();
		return true;
	end;
};
-------------------------------------------------------------------------------
sat_obj3 = obj {
	nam = 'sat_obj3';

	_chip = false;

	dsc = function(s)
		local pic;

		pic = sget_pic(27, s._chip);
		return txtc('{' .. img(pic) .. '} ');
	end;

	act = function(s)
		if not s._chip then return false; end
		sinv_add(27);
		s._chip = false;
		return true;
	end;

	used = function(s, w)
		if s._chip then return false; end
		if not w then return false; end
		if not w._chip then return false; end
		if w._chip ~= 27 then return false; end
		sinv_del(27);
		s._chip = true;
		sat_objs_check();
		return true;
	end;
};
-------------------------------------------------------------------------------
sat_obj4 = obj {
	nam = 'sat_obj4';

	_chip = false;

	dsc = function(s)
		local pic;

		pic = sget_pic(28, s._chip);
		return txtc('{' .. img(pic) .. '} ');
	end;

	act = function(s)
		if not s._chip then return false; end
		sinv_add(28);
		s._chip = false;
		return true;
	end;

	used = function(s, w)
		if s._chip then return false; end
		if not w then return false; end
		if not w._chip then return false; end
		if w._chip ~= 28 then return false; end
		sinv_del(28);
		s._chip = true;
		sat_objs_check();
		return true;
	end;
};
-------------------------------------------------------------------------------
sat_obj5 = obj {
	nam = 'sat_obj5';

	_chip = false;

	dsc = function(s)
		local pic;

		pic = sget_pic(29, s._chip);
		return txtc('{' .. img(pic) .. '} ');
	end;

	act = function(s)
		if not s._chip then return false; end
		sinv_add(29);
		s._chip = false;
		return true;
	end;

	used = function(s, w)
		if s._chip then return false; end
		if not w then return false; end
		if not w._chip then return false; end
		if w._chip ~= 29 then return false; end
		sinv_del(29);
		s._chip = true;
		sat_objs_check();
		return true;
	end;
};
-------------------------------------------------------------------------------
sat_obj6 = obj {
	nam = 'sat_obj6';

	_chip = false;

	dsc = function(s)
		local pic;

		pic = sget_pic(30, s._chip);
		return txtc('{' .. img(pic) .. '}');
	end;

	act = function(s)
		if not s._chip then return false; end
		sinv_add(30);
		s._chip = false;
		return true;
	end;

	used = function(s, w)
		if s._chip then return false; end
		if not w then return false; end
		if not w._chip then return false; end
		if w._chip ~= 30 then return false; end
		sinv_del(30);
		s._chip = true;
		sat_objs_check();
		return true;
	end;
};
-------------------------------------------------------------------------------
sat_objs_check = function()
	if sat_obj1._chip and sat_obj2._chip and sat_obj3._chip and
		sat_obj4._chip and sat_obj5._chip and sat_obj6._chip then
		inv():zap();
		return walk('satori_end');
	end
	return true;
end;
-------------------------------------------------------------------------------
satori_end = room {
	nam = 'zastavka_end';
	disp = '';
	enter = function()
		set_sound('sounds/end.ogg');
	end;
	obj = { 'satori_end_obj' };
};
-------------------------------------------------------------------------------
satori_end_obj = obj {
	nam = 'satori_end_obj';
	dsc = function()
		return img('blank:1x160') .. '^' .. txtc(img('pics/zast.png'));
	end;
};
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
testroom = room {
	nam = 'testr0';
	disp = function(s)
		local a;
		a = {};
		a['bb'] = 444;
		if a['bb'] == a.bb then
			return s.nam .. 'aaa' .. a.bb;
		else
			return 'oops';
		end;

	end;

	dsc = txtc(
		img('pics/4b.png') ..
		img('pics/4b.png') ..
		img('pics/4b.png') ..
		img('pics/4b.png') ..
		img('pics/4b.png') ..
		img('pics/4b.png') ..
		img('pics/4b.png') ..
		img('pics/4b.png') ..
		img('pics/4b.png') ..
		img('pics/4b.png') ..
		img('pics/4b.png') ..
		img('pics/4b.png') ..
		'^^' ..
		img('pics/4b.png') ..
		img('pics/4b.png') ..
		img('pics/4b.png') ..
		img('pics/4b.png') ..
		img('pics/4b.png') ..
		img('pics/4b.png') ..
		img('pics/4b.png') ..
		img('pics/4b.png') ..
		img('pics/4b.png') ..
		img('pics/4b.png') ..
		img('pics/4b.png') ..
		img('pics/4b.png')) .. '^^^' ..
		txtc(img('pics/6bd.png'))
		;

};

